/*
gnaughty - porn movie downloader
Copyright (C) 2002 David Moore

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/
#include "callbacks.h"
#include "gui.h"
#include "gnaughty.h"
#include "progress-cell-renderer.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <stdio.h>

GnaughtyLinksListWidget* create_links_list_widget()
{
	GnaughtyLinksListWidget* self;

	GtkTreeViewColumn *column;
	GtkCellRenderer *renderer;
	GtkTreeSelection *download_selection;

	self = g_malloc(sizeof(GnaughtyLinksListWidget));

	// make a new list_store
	self->list_store = gtk_list_store_new (LINKS_N_COLUMNS, G_TYPE_STRING, G_TYPE_STRING);

	self->list = gtk_tree_view_new_with_model (GTK_TREE_MODEL (self->list_store));
	gtk_tree_view_set_reorderable(GTK_TREE_VIEW(self->list), TRUE);
	gtk_tree_view_set_headers_clickable(GTK_TREE_VIEW(self->list), TRUE);

	g_signal_connect(self->list, "button-press-event", G_CALLBACK(links_column_clicked), NULL);

	g_object_unref (G_OBJECT (self->list_store));

	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes ("Description", renderer, "text", LINKS_DESC_COLUMN, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (self->list), column);
	gtk_tree_view_column_set_sort_column_id(column, LINKS_DESC_COLUMN);

	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes ("URL", renderer, "text", LINKS_URL_COLUMN, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (self->list), column);
	gtk_tree_view_column_set_sort_column_id(column, LINKS_URL_COLUMN);

	download_selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (self->list));
	gtk_tree_selection_set_mode (download_selection, GTK_SELECTION_MULTIPLE);

	return self;
}

GnaughtyDownloadsListWidget* create_downloads_list_widget()
{
	GnaughtyDownloadsListWidget* self;

	GtkTreeViewColumn *column;
	GtkCellRenderer* textrenderer;
	GtkCellRenderer* progressrenderer;
	GtkTreeSelection *movie_selection;

	self = g_malloc(sizeof(GnaughtyDownloadsListWidget));

	// make a new list_store
	self->list_store = gtk_list_store_new (DOWNLOADS_N_COLUMNS, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_FLOAT);

	self->list = gtk_tree_view_new_with_model (GTK_TREE_MODEL (self->list_store));
	gtk_tree_view_set_reorderable(GTK_TREE_VIEW(self->list), TRUE);
	gtk_tree_view_set_headers_clickable(GTK_TREE_VIEW(self->list), TRUE);

	g_signal_connect(self->list, "button-press-event", G_CALLBACK(download_column_clicked), NULL);
	g_signal_connect(self->list, "popup-menu", (GCallback)show_download_popup, GTK_TREE_VIEW (self->list));

	g_object_unref (G_OBJECT (self->list_store));

	textrenderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes ("URL", textrenderer, "text", DOWNLOADS_URL_COLUMN, NULL);
	gtk_tree_view_column_set_resizable(column, TRUE);
	gtk_tree_view_append_column (GTK_TREE_VIEW (self->list), column);
	gtk_tree_view_column_set_sort_column_id(column, DOWNLOADS_URL_COLUMN);

	textrenderer = gtk_cell_renderer_text_new();
	column = gtk_tree_view_column_new_with_attributes ("Status", textrenderer, "text", DOWNLOADS_STATUS_COLUMN, NULL);
	gtk_tree_view_column_set_resizable(column, TRUE);
	gtk_tree_view_append_column (GTK_TREE_VIEW (self->list), column);
	gtk_tree_view_column_set_sort_column_id(column, DOWNLOADS_STATUS_COLUMN);

	progressrenderer = gtk_cell_renderer_progress_new();
	column = gtk_tree_view_column_new_with_attributes ("Progress", progressrenderer, "percentage", DOWNLOADS_PROGRESS_COLUMN, NULL);
	gtk_tree_view_column_set_resizable(column, TRUE);
	gtk_tree_view_append_column (GTK_TREE_VIEW (self->list), column);
	gtk_tree_view_column_set_sort_column_id(column, DOWNLOADS_PROGRESS_COLUMN);

	movie_selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (self->list));
	gtk_tree_selection_set_mode (movie_selection, GTK_SELECTION_MULTIPLE);

	return self;
}
// vim:noexpandtab:ts=4 sw=4:
