#ifndef PROGRESS_CELL_RENDERER_INCLUDED
#define PROGRESS_CELL_RENDERER_INCLUDED

#include <gtk/gtk.h>

/* Some boilerplate GObject type check and type cast macros.  'klass' is used
 * here instead of 'class', because 'class' is a c++ keyword */

#define CUSTOM_TYPE_CELL_RENDERER_PROGRESS (gtk_cell_renderer_progress_get_type())
#define CUSTOM_CELL_RENDERER_PROGRESS(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), CUSTOM_TYPE_CELL_RENDERER_PROGRESS, CellRendererProgress))
#define CUSTOM_CELL_RENDERER_PROGRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CUSTOM_TYPE_CELL_RENDERER_PROGRESS, CellRendererProgressClass))
#define CUSTOM_IS_CELL_PROGRESS_PROGRESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CUSTOM_TYPE_CELL_RENDERER_PROGRESS))
#define CUSTOM_IS_CELL_PROGRESS_PROGRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CUSTOM_TYPE_CELL_RENDERER_PROGRESS))
#define CUSTOM_CELL_RENDERER_PROGRESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CUSTOM_TYPE_CELL_RENDERER_PROGRESS, CellRendererProgressClass))

typedef struct _CellRendererProgress CellRendererProgress;
typedef struct _CellRendererProgressClass CellRendererProgressClass;

/* CellRendererProgress: Our custom cell renderer structure. Extend
 * according to need */

struct _CellRendererProgress {
    GtkCellRenderer   parent;
    gdouble           progress;
};

struct _CellRendererProgressClass {
    GtkCellRendererClass
    parent_class;
};

GType gtk_cell_renderer_progress_get_type();
GtkCellRenderer* gtk_cell_renderer_progress_new();

#endif // PROGRESS_CELL_RENDERER_INCLUDED
